﻿@page "/todo-detail/{Mode}"
@page "/todo-detail/{Mode}/{Id:int}"

@inject ITodosRepository TodosRepository

<MudText Typo="Typo.h5" Color="Color.Primary" Class="mb-4">@($"Todo詳細（Mode={Mode}, Id={Id}）")</MudText>

<MudTextField Label="タイトル" @bind-Value="todo.Title" ReadOnly="@IsReadOnly()" />
<MudCheckBox Label="完了" @bind-Checked="todo.IsDone" ReadOnly="@IsReadOnly()" />

<br />

@if (Mode == "Create")
{
    <MudButton Variant="Variant.Filled" OnClick="ShowNotImplemented">登録</MudButton>
}

@if (Mode == "Edit")
{
    <MudButton Variant="Variant.Filled" OnClick="ShowNotImplemented">保存</MudButton>
}

@if (Mode == "Delete")
{
    <MudButton Variant="Variant.Filled" Color="Color.Secondary" OnClick="ShowNotImplemented">削除</MudButton>
}

<MudButton Variant="Variant.Filled" Link="@($"/todo-list")" Class="ml-2">キャンセル</MudButton>

@code {
    [Parameter]
    public string Mode { get; set; }

    [Parameter]
    public int Id { get; set; } = 0;

    private TodoEntity todo = new();

    protected override async Task OnInitializedAsync()
    {
        if (Mode == "Create")
        {
            return;
        }

        todo = await TodosRepository.GetTodo(Id);
    }

    private bool IsReadOnly()
    {
        if (Mode == "Create" || Mode == "Edit")
        {
            return false;
        }

        return true;
    }

    private void ShowNotImplemented()
    {
        Snackbar.Add("Sorry. Not implemented.", Severity.Warning);
    }
}